<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import {
    getProductRoute,
    getProductName,
    getTranslatedProperty,
  } from '@shopware-pwa/helpers-next';

  const props = withDefaults(
    defineProps<{
      product: Product;
      allowRedirect?: boolean;
    }>(),
    {
      allowRedirect: false,
    },
  );

  const emit = defineEmits<{
    (e: 'change', selected: Product): void;
  }>();

  const isLoading = ref<boolean>();

  const router = useRouter();
  const { handleChange, getOptionGroups, getSelectedOptions, findVariantForSelectedOptions } =
    useProductConfigurator();

  const isOptionSelected = (optionId: string) =>
    Object.values(getSelectedOptions.value).includes(optionId);

  const onHandleChange = async () => {
    isLoading.value = true;
    const variantFound = await findVariantForSelectedOptions(getSelectedOptions.value);

    const selectedOptionsVariantPath = getProductRoute(variantFound);
    if (props.allowRedirect && selectedOptionsVariantPath) {
      try {
        router.push(selectedOptionsVariantPath);
      } catch (error) {
        console.error('incorrect URL', selectedOptionsVariantPath);
      }
    } else if (variantFound) {
      emit('change', variantFound);
    }
    isLoading.value = false;
  };
</script>

<template>
  <div class="relative flex flex-col space-y-3">
    <SwLoading
      v-if="isLoading"
      class="text-primary z-loading absolute inset-0 bg-white/80 text-3xl"
    />
    <div v-for="optionGroup in getOptionGroups" :key="optionGroup.id">
      <h3 class="text-(sm information-dark) font-bold capitalize">
        {{ getTranslatedProperty(optionGroup, 'name') }}
      </h3>
      <fieldset class="mt-2 flex-1">
        <legend class="sr-only">
          {{ $t('product.choose') }} {{ getTranslatedProperty(optionGroup, 'name') }}
        </legend>
        <div class="gap3 flex flex-wrap">
          <SwSelect
            v-if="optionGroup.displayType === 'select'"
            v-model="getSelectedOptions[getTranslatedProperty(optionGroup, 'name')]"
            :options="optionGroup.options"
            class="w-full"
            @update:model-value="
              handleChange(
                getTranslatedProperty(optionGroup, 'name'),
                getSelectedOptions[getTranslatedProperty(optionGroup, 'name')],
                onHandleChange,
              )
            "
          />

          <template v-else>
            <div v-for="option in optionGroup.options" :key="option.id">
              <SwTooltip :content="getTranslatedProperty(option, 'name')" position="topCenter">
                <img
                  v-if="optionGroup.displayType === 'media' && option.media?.url"
                  class="h-9 w-9 rounded-full border p-0"
                  :class="{
                    'border-primary border-2': isOptionSelected(option.id),
                  }"
                  :alt="getProductName({ product }) ?? ''"
                  :src="option.media?.url"
                  @click="
                    handleChange(
                      getTranslatedProperty(optionGroup, 'name'),
                      option.id,
                      onHandleChange,
                    )
                  "
                />

                <SwButton
                  v-else-if="optionGroup.displayType === 'color' && option.colorHexCode"
                  fab
                  variant="action"
                  class="!h-9 !w-9"
                  :class="{
                    'border-primary border-2': isOptionSelected(option.id),
                  }"
                  :style="{ backgroundColor: option.colorHexCode }"
                  @click="
                    handleChange(
                      getTranslatedProperty(optionGroup, 'name'),
                      option.id,
                      onHandleChange,
                    )
                  "
                />

                <SwButton
                  v-else
                  data-testid="product-variant"
                  :variant="isOptionSelected(option.id) ? 'primary' : 'action'"
                  size="large"
                  :class="{
                    'bg-primary text-white': isOptionSelected(option.id),
                  }"
                  @click="
                    handleChange(
                      getTranslatedProperty(optionGroup, 'name'),
                      option.id,
                      onHandleChange,
                    )
                  "
                >
                  <p :id="`${option.id}-choice-label`" data-testid="product-variant-text">
                    {{ getTranslatedProperty(option, 'name') }}
                  </p>
                </SwButton>
              </SwTooltip>
            </div>
          </template>
        </div>
      </fieldset>
    </div>
  </div>
</template>
